name: Test

on:

  pull_request:
    branches: [ main ]
    paths:
      - '.github/workflows/test.yml'
      - 'pyproject.toml'
      - 'setup.cfg'
      - '**.py'

  push:
    branches: [ main ]
    paths:
      - '.github/workflows/test.yml'
      - 'pyproject.toml'
      - 'setup.cfg'
      - '**.py'

  # Allow job to be triggered manually.
  workflow_dispatch:

# Cancel in-progress jobs when pushing to the same branch.
concurrency:
  cancel-in-progress: true
  group: ${{ github.workflow }}-${{ github.ref }}

jobs:
  test:
    runs-on: ${{ matrix.os }}
    strategy:
      matrix:
        os: ["ubuntu-20.04"]
        python-version: [
          '3.6', '3.12',
          'pypy-3.6', 'pypy-3.10',
        ]
    steps:
      - uses: actions/checkout@v4

      - name: Setup Python
        uses: actions/setup-python@v5
        with:
          python-version: ${{ matrix.python-version }}
          architecture: x64
          cache: 'pip'
          cache-dependency-path: 'setup.cfg'

      - name: Install dependencies for PyPy
        if: startsWith(matrix.python-version, 'pypy')
        run: |
          sudo apt-get install libxml2-dev libxslt-dev

      - name: Install dependencies
        run: |
          python -m pip install --upgrade pip
          python -m pip install --editable=.[test,develop]

      - name: Check code style
        if: matrix.python-version != '3.6' && matrix.python-version != 'pypy-3.6'
        run: |
          poe lint

      - name: Run tests
        run: |
          poe test-coverage

      # https://github.com/codecov/codecov-action
      - name: Upload coverage results to Codecov
        uses: codecov/codecov-action@v3
        with:
          fail_ci_if_error: false
        continue-on-error: true
